
import parser.*;

public class AspectJExample {
    public static aspect Evaluation {
        public abstract int parser.ExpressionParser.Expression.evaluate();
        
        public int parser.ExpressionParser.Default.Number.evaluate() {
            return Integer.parseInt(value().getImage());
        }
        
        public int parser.ExpressionParser.Default.Addition.evaluate() {
            return operand1().evaluate() + operand2().evaluate();
        }
        
        public int parser.ExpressionParser.Default.Subtraction.evaluate() {
            return operand1().evaluate() - operand2().evaluate();
        }
        
        public int parser.ExpressionParser.Default.Multiplication.evaluate() {
            return operand1().evaluate() * operand2().evaluate();
        }
        
        public int parser.ExpressionParser.Default.Division.evaluate() {
            return operand1().evaluate() / operand2().evaluate();
        }
        
    }
    
    public static void main(String[] args) {
        try {
            ExpressionParser.Root root = new ExpressionParser().parseRoot(new java.io.File(args[0]));
            ExpressionParser.Expression expression = root.expression();
            //System.out.println(expression.evaluate());
            //System.out.println(root);
        } catch(Exception x) {
            x.printStackTrace();
        }
    }
}

